# $Id: Base.pm,v 1.1.1.1 2001/05/18 16:36:37 matt Exp $
# version 0.10 - Kip Hampton <khampton@totalcinema.com>
# version 0.13 - Robin Berjon <robin@knowscape.com>
# version 0.15 - Kip Hampton <khampton@totalcinema.com>

package XML::Filter::Base;

use strict;
use vars qw($VERSION $DEBUG $LEXICAL_HANDLER $DECL_HANDLER);

$VERSION = '0.15';

sub notation_decl {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'DTDHandler'}->notation_decl(@_); } if $self->{'DTDHandler'};
    return $ret if $self->{'DTDHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "notation_decl"/;
    undef $@;
    return;
}

sub resolve_entity {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'EntityResolver'}->resolve_entity(@_); } if $self->{'EntityResolver'};
    return $ret if $self->{'EntityResolver'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "resolve_entity"/;
    undef $@;
    return;
}

sub start_cdata {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'DocumentHandler'}->start_cdata(@_); } if $self->{'DocumentHandler'};
    return $ret if $self->{'DocumentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "start_cdata"/;
    eval { $ret = $self->{'http://xml.org/sax/handlers/LexicalHandler'}->start_cdata(@_); } if $self->{'http://xml.org/sax/handlers/LexicalHandler'};
    return $ret if $self->{'http://xml.org/sax/handlers/LexicalHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "start_cdata"/;
    undef $@;
    return;
}

sub set_document_locator {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'ContentHandler'}->set_document_locator(@_); } if $self->{'ContentHandler'};
    return $ret if $self->{'ContentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "set_document_locator"/;
    eval { $ret = $self->{'DocumentHandler'}->set_document_locator(@_); } if $self->{'DocumentHandler'};
    return $ret if $self->{'DocumentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "set_document_locator"/;
    eval { $ret = $self->{'Handler'}->set_document_locator(@_); } if $self->{'Handler'};
    return $ret if $self->{'Handler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "set_document_locator"/;
    undef $@;
    return;
}

sub xml_decl {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'DTDHandler'}->xml_decl(@_); } if $self->{'DTDHandler'};
    return $ret if $self->{'DTDHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "xml_decl"/;
    undef $@;
    return;
}

sub processing_instruction {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'ContentHandler'}->processing_instruction(@_); } if $self->{'ContentHandler'};
    return $ret if $self->{'ContentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "processing_instruction"/;
    eval { $ret = $self->{'DocumentHandler'}->processing_instruction(@_); } if $self->{'DocumentHandler'};
    return $ret if $self->{'DocumentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "processing_instruction"/;
    eval { $ret = $self->{'Handler'}->processing_instruction(@_); } if $self->{'Handler'};
    return $ret if $self->{'Handler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "processing_instruction"/;
    undef $@;
    return;
}

sub start_prefix_mapping {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'ContentHandler'}->start_prefix_mapping(@_); } if $self->{'ContentHandler'};
    return $ret if $self->{'ContentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "start_prefix_mapping"/;
    eval { $ret = $self->{'Handler'}->start_prefix_mapping(@_); } if $self->{'Handler'};
    return $ret if $self->{'Handler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "start_prefix_mapping"/;
    undef $@;
    return;
}

sub entity_reference {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'DocumentHandler'}->entity_reference(@_); } if $self->{'DocumentHandler'};
    return $ret if $self->{'DocumentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "entity_reference"/;
    eval { $ret = $self->{'Handler'}->entity_reference(@_); } if $self->{'Handler'};
    return $ret if $self->{'Handler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "entity_reference"/;
    undef $@;
    return;
}

sub attlist_decl {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'DTDHandler'}->attlist_decl(@_); } if $self->{'DTDHandler'};
    return $ret if $self->{'DTDHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "attlist_decl"/;
    undef $@;
    return;
}

sub error {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'ErrorHandler'}->error(@_); } if $self->{'ErrorHandler'};
    return $ret if $self->{'ErrorHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "error"/;
    undef $@;
    return;
}

sub unparsed_entity_decl {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'DTDHandler'}->unparsed_entity_decl(@_); } if $self->{'DTDHandler'};
    return $ret if $self->{'DTDHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "unparsed_entity_decl"/;
    undef $@;
    return;
}

sub end_entity {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'http://xml.org/sax/handlers/LexicalHandler'}->end_entity(@_); } if $self->{'http://xml.org/sax/handlers/LexicalHandler'};
    return $ret if $self->{'http://xml.org/sax/handlers/LexicalHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "end_entity"/;
    undef $@;
    return;
}

sub end_element {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'ContentHandler'}->end_element(@_); } if $self->{'ContentHandler'};
    return $ret if $self->{'ContentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "end_element"/;
    eval { $ret = $self->{'DocumentHandler'}->end_element(@_); } if $self->{'DocumentHandler'};
    return $ret if $self->{'DocumentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "end_element"/;
    eval { $ret = $self->{'Handler'}->end_element(@_); } if $self->{'Handler'};
    return $ret if $self->{'Handler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "end_element"/;
    undef $@;
    return;
}

sub comment {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'DocumentHandler'}->comment(@_); } if $self->{'DocumentHandler'};
    return $ret if $self->{'DocumentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "comment"/;
    eval { $ret = $self->{'http://xml.org/sax/handlers/LexicalHandler'}->comment(@_); } if $self->{'http://xml.org/sax/handlers/LexicalHandler'};
    return $ret if $self->{'http://xml.org/sax/handlers/LexicalHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "comment"/;
    undef $@;
    return;
}

sub element_decl {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'DTDHandler'}->element_decl(@_); } if $self->{'DTDHandler'};
    return $ret if $self->{'DTDHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "element_decl"/;
    undef $@;
    return;
}

sub attribute_decl {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'http://xml.org/sax/handlers/DeclHandler'}->attribute_decl(@_); } if $self->{'http://xml.org/sax/handlers/DeclHandler'};
    return $ret if $self->{'http://xml.org/sax/handlers/DeclHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "attribute_decl"/;
    eval { $ret = $self->{'Handler'}->attribute_decl(@_); } if $self->{'Handler'};
    return $ret if $self->{'Handler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "attribute_decl"/;
    undef $@;
    return;
}

sub fatal_error {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'ErrorHandler'}->fatal_error(@_); } if $self->{'ErrorHandler'};
    return $ret if $self->{'ErrorHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "fatal_error"/;
    undef $@;
    return;
}

sub start_document {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'ContentHandler'}->start_document(@_); } if $self->{'ContentHandler'};
    return $ret if $self->{'ContentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "start_document"/;
    eval { $ret = $self->{'DocumentHandler'}->start_document(@_); } if $self->{'DocumentHandler'};
    return $ret if $self->{'DocumentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "start_document"/;
    eval { $ret = $self->{'Handler'}->start_document(@_); } if $self->{'Handler'};
    return $ret if $self->{'Handler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "start_document"/;
    undef $@;
    return;
}

sub external_entity_decl {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'http://xml.org/sax/handlers/DeclHandler'}->external_entity_decl(@_); } if $self->{'http://xml.org/sax/handlers/DeclHandler'};
    return $ret if $self->{'http://xml.org/sax/handlers/DeclHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "external_entity_decl"/;
    eval { $ret = $self->{'Handler'}->external_entity_decl(@_); } if $self->{'Handler'};
    return $ret if $self->{'Handler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "external_entity_decl"/;
    undef $@;
    return;
}

sub warning {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'ErrorHandler'}->warning(@_); } if $self->{'ErrorHandler'};
    return $ret if $self->{'ErrorHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "warning"/;
    undef $@;
    return;
}

sub doctype_decl {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'DTDHandler'}->doctype_decl(@_); } if $self->{'DTDHandler'};
    return $ret if $self->{'DTDHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "doctype_decl"/;
    undef $@;
    return;
}

sub entity_decl {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'http://xml.org/sax/handlers/DeclHandler'}->entity_decl(@_); } if $self->{'http://xml.org/sax/handlers/DeclHandler'};
    return $ret if $self->{'http://xml.org/sax/handlers/DeclHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "entity_decl"/;
    eval { $ret = $self->{'DTDHandler'}->entity_decl(@_); } if $self->{'DTDHandler'};
    return $ret if $self->{'DTDHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "entity_decl"/;
    undef $@;
    return;
}

sub end_document {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'ContentHandler'}->end_document(@_); } if $self->{'ContentHandler'};
    return $ret if $self->{'ContentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "end_document"/;
    eval { $ret = $self->{'DocumentHandler'}->end_document(@_); } if $self->{'DocumentHandler'};
    return $ret if $self->{'DocumentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "end_document"/;
    eval { $ret = $self->{'Handler'}->end_document(@_); } if $self->{'Handler'};
    return $ret if $self->{'Handler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "end_document"/;
    undef $@;
    return;
}

sub start_element {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'ContentHandler'}->start_element(@_); } if $self->{'ContentHandler'};
    return $ret if $self->{'ContentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "start_element"/;
    eval { $ret = $self->{'DocumentHandler'}->start_element(@_); } if $self->{'DocumentHandler'};
    return $ret if $self->{'DocumentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "start_element"/;
    eval { $ret = $self->{'Handler'}->start_element(@_); } if $self->{'Handler'};
    return $ret if $self->{'Handler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "start_element"/;
    undef $@;
    return;
}

sub start_dtd {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'http://xml.org/sax/handlers/LexicalHandler'}->start_dtd(@_); } if $self->{'http://xml.org/sax/handlers/LexicalHandler'};
    return $ret if $self->{'http://xml.org/sax/handlers/LexicalHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "start_dtd"/;
    undef $@;
    return;
}

sub end_prefix_mapping {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'ContentHandler'}->end_prefix_mapping(@_); } if $self->{'ContentHandler'};
    return $ret if $self->{'ContentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "end_prefix_mapping"/;
    eval { $ret = $self->{'Handler'}->end_prefix_mapping(@_); } if $self->{'Handler'};
    return $ret if $self->{'Handler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "end_prefix_mapping"/;
    undef $@;
    return;
}

sub end_dtd {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'http://xml.org/sax/handlers/LexicalHandler'}->end_dtd(@_); } if $self->{'http://xml.org/sax/handlers/LexicalHandler'};
    return $ret if $self->{'http://xml.org/sax/handlers/LexicalHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "end_dtd"/;
    undef $@;
    return;
}

sub characters {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'ContentHandler'}->characters(@_); } if $self->{'ContentHandler'};
    return $ret if $self->{'ContentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "characters"/;
    eval { $ret = $self->{'DocumentHandler'}->characters(@_); } if $self->{'DocumentHandler'};
    return $ret if $self->{'DocumentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "characters"/;
    eval { $ret = $self->{'Handler'}->characters(@_); } if $self->{'Handler'};
    return $ret if $self->{'Handler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "characters"/;
    undef $@;
    return;
}

sub end_cdata {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'DocumentHandler'}->end_cdata(@_); } if $self->{'DocumentHandler'};
    return $ret if $self->{'DocumentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "end_cdata"/;
    eval { $ret = $self->{'http://xml.org/sax/handlers/LexicalHandler'}->end_cdata(@_); } if $self->{'http://xml.org/sax/handlers/LexicalHandler'};
    return $ret if $self->{'http://xml.org/sax/handlers/LexicalHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "end_cdata"/;
    undef $@;
    return;
}

sub skipped_entity {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'ContentHandler'}->skipped_entity(@_); } if $self->{'ContentHandler'};
    return $ret if $self->{'ContentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "skipped_entity"/;
    eval { $ret = $self->{'Handler'}->skipped_entity(@_); } if $self->{'Handler'};
    return $ret if $self->{'Handler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "skipped_entity"/;
    undef $@;
    return;
}

sub ignorable_whitespace {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'ContentHandler'}->ignorable_whitespace(@_); } if $self->{'ContentHandler'};
    return $ret if $self->{'ContentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "ignorable_whitespace"/;
    eval { $ret = $self->{'DocumentHandler'}->ignorable_whitespace(@_); } if $self->{'DocumentHandler'};
    return $ret if $self->{'DocumentHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "ignorable_whitespace"/;
    eval { $ret = $self->{'Handler'}->ignorable_whitespace(@_); } if $self->{'Handler'};
    return $ret if $self->{'Handler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "ignorable_whitespace"/;
    undef $@;
    return;
}

sub internal_entity_decl {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'http://xml.org/sax/handlers/DeclHandler'}->internal_entity_decl(@_); } if $self->{'http://xml.org/sax/handlers/DeclHandler'};
    return $ret if $self->{'http://xml.org/sax/handlers/DeclHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "internal_entity_decl"/;
    eval { $ret = $self->{'Handler'}->internal_entity_decl(@_); } if $self->{'Handler'};
    return $ret if $self->{'Handler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "internal_entity_decl"/;
    undef $@;
    return;
}

sub start_entity {
    my $self = shift;
    my $ret;
    eval { $ret = $self->{'http://xml.org/sax/handlers/LexicalHandler'}->start_entity(@_); } if $self->{'http://xml.org/sax/handlers/LexicalHandler'};
    return $ret if $self->{'http://xml.org/sax/handlers/LexicalHandler'} and not $@;
    die $@ if $@ and $@ !~ m/Can't locate object method "start_entity"/;
    undef $@;
    return;
}

sub new {
    my $class = shift;
    my %options = @_;

# we could set the SAX version
#    if ($options{ContentHandler})     { $options{SAXVersion} = 2; }
#    elsif ($options{DocumentHandler}) { $options{SAXVersion} = 1; }
    $options{Handler}           ||= XML::Filter::Base::NoHandler->new;
    $options{$LEXICAL_HANDLER}  ||= $options{Handler};
    $options{DTDHandler}        ||= $options{Handler};
    $options{EntityResolver}    ||= $options{Handler};
    $options{ErrorHandler}      ||= $options{Handler};

# these are not defaulted (for now at least)
#    $options{DocumentHandler}   ||= $options{Handler};
#    $options{ContentHandler}    ||= $options{Handler};
#    $options{$DECL_HANDLER}     ||= $options{Handler};

    return bless \%options, $class;
}

package XML::Filter::Base::NoHandler;

# we need a fake handler that doesn't implement anything, this
# simplifies the code a lot (though given the recent changes,
# it may be better to do without)
sub new {
    return bless {};
}


1;

=pod

=head1 NAME

XML::Filter::Base - Base class for XML::Filter modules

=head1 SYNOPSIS

  package MyFilter;
  use XML::Filter::Base;
  @ISA = ('XML::Filter::Base');

=head1 DESCRIPTION

This module has a very simple task - to be a base class for PerlSAX
filters. It's default behaviour is to pass the input directly to the
output unchanged. It can be useful to use this module as a base class
so you don't have to, for example, implement the characters() callback.

=head1 METHODS

It would be rather useless to describe all the methods that this
module implements here. They are all the methods supported in SAX1 and
SAX2. In case your memory is a little short, here is a list. The
apparent duplicates are there so that both versions of SAX can be
supported.

=over 4

=item * start_document

=item * end_document

=item * start_element

=item * start_document

=item * end_document

=item * start_element

=item * end_element

=item * characters

=item * processing_instruction

=item * ignorable_whitespace

=item * set_document_locator

=item * start_prefix_mapping

=item * end_prefix_mapping

=item * skipped_entity

=item * start_cdata

=item * end_cdata

=item * comment

=item * entity_reference

=item * notation_decl

=item * unparsed_entity_decl

=item * element_decl

=item * attlist_decl

=item * doctype_decl

=item * xml_decl

=item * entity_decl

=item * attribute_decl

=item * internal_entity_decl

=item * external_entity_decl

=item * resolve_entity

=item * start_dtd

=item * end_dtd

=item * start_entity

=item * end_entity

=item * warning

=item * error

=item * fatal_error

=back

=head1 TODO

  - more tests
  - conform to the "SAX Filters" and "Java and DOM compatibility"
  sections of the SAX2 document.

=head1 AUTHOR

Matt Sergeant, matt@sergeant.org

=head1 SEE ALSO

L<XML::Parser::PerlSAX>.

=cut

